var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
import { DataType } from "../common/DataType";
import { getObjectMetadata } from "../common/metadata";
import { Enum } from "../dto/decorator";
import { Data, Field } from "../dto/decorator";
import { AccessConditionMetadata } from "./AccessConditionMetadata";
import { HttpMethod } from "./HttpMethod";
let Permission = class Permission {
    id;
    description;
    name;
    openAccess;
    tfaRequired;
    permissionGroup;
    accessConditions;
    readOnly;
    method;
    mount;
    paramDto;
    queryDto;
    bodyDto;
    responseDto;
};
__decorate([
    Field({
        description: "Id of the permission",
        isRequired: true,
    }),
    __metadata("design:type", String)
], Permission.prototype, "id", void 0);
__decorate([
    Field({
        description: "Description of the permission",
    }),
    __metadata("design:type", String)
], Permission.prototype, "description", void 0);
__decorate([
    Field({
        description: "Display name of the permission",
        isRequired: true,
    }),
    __metadata("design:type", String)
], Permission.prototype, "name", void 0);
__decorate([
    Field({
        description: "Whether this permission has public access",
        isRequired: true,
    }),
    __metadata("design:type", Boolean)
], Permission.prototype, "openAccess", void 0);
__decorate([
    Field({
        description: "Whether this permission require tfa",
        isRequired: true,
    }),
    __metadata("design:type", Boolean)
], Permission.prototype, "tfaRequired", void 0);
__decorate([
    Field({
        description: "Name of the permission group",
        isRequired: true,
    }),
    __metadata("design:type", String)
], Permission.prototype, "permissionGroup", void 0);
__decorate([
    Field({
        description: "The configurable access condition of this permission",
        isRequired: true,
        vectorProps: {},
        elementDto: getObjectMetadata(AccessConditionMetadata),
    }),
    __metadata("design:type", Array)
], Permission.prototype, "accessConditions", void 0);
__decorate([
    Field({
        description: "Whether this permission does not allow data modification",
        isRequired: true,
    }),
    __metadata("design:type", Boolean)
], Permission.prototype, "readOnly", void 0);
__decorate([
    Field({
        description: "Http method used to call the API",
        isRequired: true,
        ...Enum(HttpMethod),
    }),
    __metadata("design:type", String)
], Permission.prototype, "method", void 0);
__decorate([
    Field({
        description: "Http Mount point of the API",
        isRequired: true,
    }),
    __metadata("design:type", String)
], Permission.prototype, "mount", void 0);
__decorate([
    Field({
        description: "Validation dto of request param",
    }),
    __metadata("design:type", Object)
], Permission.prototype, "paramDto", void 0);
__decorate([
    Field({
        description: "Validation dto of request queries",
    }),
    __metadata("design:type", Object)
], Permission.prototype, "queryDto", void 0);
__decorate([
    Field({
        description: "Validation dto of request body (for POST / PUT)",
    }),
    __metadata("design:type", Object)
], Permission.prototype, "bodyDto", void 0);
__decorate([
    Field({
        description: "Validation dto of response body",
    }),
    __metadata("design:type", Object)
], Permission.prototype, "responseDto", void 0);
Permission = __decorate([
    Data()
], Permission);
export { Permission };
let ApiInfoResponse = class ApiInfoResponse {
    permissions;
};
__decorate([
    Field({
        description: "All permissions of the service",
        isRequired: true,
        elementDto: getObjectMetadata(Permission),
        vectorProps: { elementDataType: DataType.OBJECT },
    }),
    __metadata("design:type", Array)
], ApiInfoResponse.prototype, "permissions", void 0);
ApiInfoResponse = __decorate([
    Data()
], ApiInfoResponse);
export { ApiInfoResponse };
